## vbam-2.1.11.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
cmake_policy(VERSION 3.19...3.28.3)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

if(WIN32)
    include(RemoveStrawberryPerlFromPATH)

    find_program(POWERSHELL
        NAMES powershell.exe pwsh.exe
        HINTS "/Windows/System32/WindowsPowerShell/v1.0"
        REQUIRED)
else()
    find_program(POWERSHELL pwsh)
endif()

if(UPDATE_APPCAST)
    include(UpdateAppcast)
endif()

if(TAG_RELEASE)
    include(MakeReleaseCommitAndTag)
endif()

set(VCPKG_DEPS pkgconf zlib pthreads "sdl2[samplerate]" gettext wxwidgets)

set(VCPKG_DEPS_OPTIONAL
    sfml   ENABLE_LINK
    ffmpeg ENABLE_FFMPEG
    faudio ENABLE_FAUDIO
)

include(Set-Toolchain-vcpkg)

# Use ccache if available and not already enabled on the command line.
# This has to be done before the project() call.
if(NOT CMAKE_CXX_COMPILER_LAUNCHER)
    find_program(CCACHE_EXECUTABLE ccache)
    if(CCACHE_EXECUTABLE)
        message(STATUS "Enabling ccache")

        set(CMAKE_C_COMPILER_LAUNCHER        ${CCACHE_EXECUTABLE} CACHE STRING "C compiler launcher"     FORCE)
        set(CMAKE_CXX_COMPILER_LAUNCHER      ${CCACHE_EXECUTABLE} CACHE STRING "C++ compiler launcher"   FORCE)
        set(CMAKE_ASM_NASM_COMPILER_LAUNCHER ${CCACHE_EXECUTABLE} CACHE STRING "nasm assembler launcher" FORCE)
    endif()
endif()

find_package(Git)

# Make sure we pull in the submodules on windows and mingw.
if(GIT_FOUND AND WIN32)
    # Win32 deps submodule
    set(SUBMODULE_MANUAL_UPDATE FALSE)

    if(EXISTS "${CMAKE_SOURCE_DIR}/.git" AND NOT EXISTS "${CMAKE_SOURCE_DIR}/dependencies/mingw-xaudio/include")
        set(SUBMODULE_MANUAL_UPDATE TRUE)
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" submodule update --init --remote --recursive
            RESULT_VARIABLE SUBMODULE_UPDATE_STATUS
            WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
        )
    endif()

    if(NOT EXISTS "${CMAKE_SOURCE_DIR}/dependencies/mingw-xaudio/include")
        if(NOT (SUBMODULE_MANUAL_UPDATE AND SUBMODULE_UPDATE_STATUS EQUAL 0))
            message(FATAL_ERROR "Please pull in git submodules, e.g.\nrun: git submodule update --init --remote --recursive")
        endif()
    endif()
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED True)

project(VBA-M C CXX)

include(CTest)
include(FetchContent)
include(GNUInstallDirs)
include(Architecture)
include(Options)
include(Toolchain)
include(Dependencies)

# Disable tests when not in a git checkout.
if(NOT EXISTS "${CMAKE_SOURCE_DIR}/.git")
    set(BUILD_TESTING OFF)
endif()

# Configure gtest
if(BUILD_TESTING)
    FetchContent_Declare(googletest
        URL https://github.com/google/googletest/archive/2d16ed055d09c3689d44b272adc097393de948a0.zip
        EXCLUDE_FROM_ALL
    )

    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
    FetchContent_MakeAvailable(googletest)

    include(GoogleTest)
endif()

if(NOT CMAKE_PREFIX_PATH AND (NOT ("$ENV{CMAKE_PREFIX_PATH}" STREQUAL "")))
    set(CMAKE_PREFIX_PATH "$ENV{CMAKE_PREFIX_PATH}")
endif()

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Build Type" FORCE)
elseif(NOT CMAKE_BUILD_TYPE MATCHES "^(Release|Debug|RelWithDebInfo|MinSizeRel)$")
    message(FATAL_ERROR "Invalid CMAKE_BUILD_TYPE: '${CMAKE_BUILD_TYPE}', must be one of: 'Release', 'Debug', 'RelWithDebInfo' or 'MinSizeRel'")
endif()

# Link debug libs for RelWithDebInfo
if(CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    set(CMAKE_MAP_IMPORTED_CONFIG_RELWITHDEBINFO "Debug")
endif()

set(MSYS OFF)
if(NOT "$ENV{MSYSTEM_PREFIX}" STREQUAL "")
    set(MSYS ON)
endif()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    include(GitTagVersion)
    git_version(VBAM_VERSION VBAM_REVISION VBAM_VERSION_RELEASE)

    # only use the plugin to tie the configure state to the sha to force rebuilds
    # of files that depend on version.h
    include(GetGitRevisionDescription)
    get_git_head_revision(REFSPEC COMMITHASH)

    # Make sure old tags are gone from all clones.
    execute_process(
        COMMAND ${GIT_EXECUTABLE} tag -l
        OUTPUT_VARIABLE git_tags
        OUTPUT_STRIP_TRAILING_WHITESPACE
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )

    string(REGEX REPLACE ";"     "\\\\;" git_tags_lines "${git_tags}")
    string(REGEX REPLACE "\r?\n" ";"     git_tags_lines "${git_tags_lines}")

    set(found_old_tags FALSE)

    foreach(tag ${git_tags_lines})
        if(NOT tag MATCHES "^v[0-9]")
            set(found_old_tags TRUE)
            break()
        endif()
    endforeach()

    if(found_old_tags)
        # Delete all tags and fetch them from the origin.

        foreach(tag ${git_tags_lines})
            execute_process(
                COMMAND ${GIT_EXECUTABLE} tag -d ${tag}
                OUTPUT_QUIET
                ERROR_QUIET
                WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            )
        endforeach()

        execute_process(
            COMMAND ${GIT_EXECUTABLE} fetch --tags origin
            OUTPUT_QUIET
            ERROR_QUIET
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        )
    endif()
endif()

# no git or no tags, use ChangeLog
if(NOT VBAM_VERSION)
    include(ChangeLogVersion)
    changelog_version(VBAM_VERSION VBAM_REVISION VBAM_VERSION_RELEASE)
endif()

# Enable internationalization
set(LOCALEDIR ${CMAKE_INSTALL_PREFIX}/share/locale)

if(NOT TRANSLATIONS_ONLY)
    add_subdirectory(third_party/include/nonstd)
    add_subdirectory(third_party/include/stb)
    add_subdirectory(src/core)
    add_subdirectory(src/components)
    add_subdirectory(src/sdl)
endif()

add_subdirectory(src/wx)
add_subdirectory(po/wxvbam)

set(CPACK_GENERATOR "ZIP")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_PACKAGE_VERSION_MAJOR "2")
set(CPACK_PACKAGE_VERSION_MINOR "0")
set(CPACK_PACKAGE_VERSION_PATCH "0-Git-${COMMITHASH}")
list(APPEND CPACK_SOURCE_IGNORE_FILES "${CMAKE_CURRENT_SOURCE_DIR}/dependencies")
include(CPack)

=== po/wxvbam/CMakeLists.txt ===
if(NOT TRANSLATIONS_ONLY AND NOT ENABLE_WX)
    return()
endif()

file(GLOB po_files "${CMAKE_CURRENT_SOURCE_DIR}/*.po")

gettext_create_translations(wxvbam.pot ${po_files})

=== src/components/CMakeLists.txt ===
add_subdirectory(av_recording)
add_subdirectory(draw_text)
add_subdirectory(filters)
add_subdirectory(filters_agb)
add_subdirectory(filters_interframe)
add_subdirectory(user_config)

=== src/core/CMakeLists.txt ===
add_subdirectory(apu)
add_subdirectory(base)
add_subdirectory(fex)

# The vbam-core target contains both the Game Boy and Game Boy Advance
# emulators. These should be broken down into 2 separate targets. The issue lies
# with the Link and Sound emulation, which are tangled together between the two
# systems.
add_library(vbam-core STATIC)

target_sources(vbam-core
    PRIVATE
    # Game Boy
    gb/internal/gbCodes.h
    gb/internal/gbCodesCB.h
    gb/gb.cpp
    gb/gbCartData.cpp
    gb/gbCheats.cpp
    gb/gbDis.cpp
    gb/gbGfx.cpp
    gb/gbGlobals.cpp
    gb/gbMemory.cpp
    gb/gbPrinter.cpp
    gb/gbSGB.cpp
    gb/gbSound.cpp

    # Game Boy Advance
    # Built with flex -o debugger-expr-lex.cpp -P dexp_ debugger-expr.l
    gba/debugger-expr-lex.cpp
    # Built with bison -L c -o debugger-expr-yacc.cpp -H -p dexp_ debugger-expr.y
    # The yyerrorlab label handler was manually commented out to silence a
    # compiler warning.
    gba/debugger-expr-yacc.cpp
    gba/gba.cpp
    gba/gbaCpuArm.cpp
    gba/gbaCpuArmDis.cpp
    gba/gbaCpuThumb.cpp
    gba/gbaCheats.cpp
    gba/gbaCheatSearch.cpp
    gba/gbaEeprom.cpp
    gba/gbaElf.cpp
    gba/gbaFlash.cpp
    gba/gbaGfx.cpp
    gba/gbaGlobals.cpp
    gba/gbaMode0.cpp
    gba/gbaMode1.cpp
    gba/gbaMode2.cpp
    gba/gbaMode3.cpp
    gba/gbaMode4.cpp
    gba/gbaMode5.cpp
    gba/gbaPrint.cpp
    gba/gbaRtc.cpp
    gba/gbaSound.cpp
    gba/internal/gbaBios.cpp
    gba/internal/gbaBios.h
    gba/internal/gbaEreader.cpp
    gba/internal/gbaEreader.h
    gba/internal/gbaSram.cpp
    gba/internal/gbaSram.h

    PUBLIC
    # Game Boy
    gb/gb.h
    gb/gbCartData.h
    gb/gbCheats.h
    gb/gbDis.h
    gb/gbGfx.h
    gb/gbGlobals.h
    gb/gbMemory.h
    gb/gbPrinter.h
    gb/gbSGB.h
    gb/gbSound.h

    # Game Boy Advance
    gba/gba.h
    gba/gbaCheats.h
    gba/gbaCheatSearch.h
    gba/gbaCpu.h
    gba/gbaCpuArmDis.h
    gba/gbaEeprom.h
    gba/gbaElf.h
    gba/gbaFlash.h
    gba/gbaGfx.h
    gba/gbaGlobals.h
    gba/gbaInline.h
    gba/gbaPrint.h
    gba/gbaRtc.h
    gba/gbaSound.h
)

target_include_directories(vbam-core
    PUBLIC ${ZLIB_INCLUDE_DIR}
)

target_link_libraries(vbam-core
    PRIVATE vbam-core-apu vbam-fex
    PUBLIC vbam-core-base ${ZLIB_LIBRARY}
)

if(ENABLE_DEBUGGER)
    target_sources(vbam-core
        PRIVATE
        gba/gbaRemote.cpp
        gba/internal/gbaBreakpoint.cpp
        gba/internal/gbaBreakpoint.h

        PUBLIC
        gba/gbaRemote.h
    )
endif()

if(ENABLE_LINK)
    target_sources(vbam-core
        PRIVATE
        gba/gbaLink.cpp
        gba/internal/gbaSockClient.cpp
        gba/internal/gbaSockClient.h

        PUBLIC
        gba/gbaLink.h
    )

    target_include_directories(vbam-core
        PRIVATE ${SFML_INCLUDE_DIR}
    )

    target_link_libraries(vbam-core
        PRIVATE ${SFML_LIBRARIES}
    )

    # Add libintl.h
    target_include_directories(vbam-core
        PRIVATE ${LIBINTL_INC}
    )
    target_link_libraries(vbam-core
        PRIVATE ${NLS_LIBS}
    )
endif()

add_subdirectory(test)

=== src/libretro/Makefile ===
DEBUG=0
TILED_RENDERING=0
STATIC_LINKING=0
FRONTEND_SUPPORTS_RGB565=1
NO_LINK=1

SPACE :=
SPACE := $(SPACE) $(SPACE)
BACKSLASH :=
BACKSLASH := \$(BACKSLASH)
filter_out1 = $(filter-out $(firstword $1),$1)
filter_out2 = $(call filter_out1,$(call filter_out1,$1))

ifeq ($(platform),)
platform = unix
ifeq ($(shell uname -a),)
	platform = win
else ifneq ($(findstring MINGW,$(shell uname -a)),)
	platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
	platform = osx
	arch = intel
ifeq ($(shell uname -p),arm)
	arch = arm
endif
ifeq ($(shell uname -p),powerpc)
	arch = ppc
endif
else ifneq ($(findstring win,$(shell uname -a)),)
	platform = win
endif
endif

# system platform
system_platform = unix
ifeq ($(shell uname -a),)
EXE_EXT = .exe
	system_platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
	system_platform = osx
	arch = intel
ifeq ($(shell uname -p),arm)
	arch = arm
endif
ifeq ($(shell uname -p),powerpc)
	arch = ppc
endif
else ifneq ($(findstring MINGW,$(shell uname -a)),)
	system_platform = win
endif

CORE_DIR     := ..
LIBRETRO_DIR := $(CORE_DIR)/libretro
TARGET_NAME  := vbam

VBAM_VERSION   := $(shell sed -En 's/.*\[([0-9]+[^]]+).*/\1/p; T; q' ../../CHANGELOG.md 2>/dev/null)
TAG_COMMIT     := $(shell git rev-list -n 1 v$(VBAM_VERSION) --abbrev-commit 2>/dev/null)
CURRENT_COMMIT := $(shell git rev-parse --short HEAD 2>/dev/null)

CXXFLAGS += -DVBAM_VERSION=\"$(VBAM_VERSION)\"
ifneq ($(CURRENT_COMMIT),$(TAG_COMMIT))
	CXXFLAGS += -DGIT_COMMIT=\"$(CURRENT_COMMIT)\"
endif

# UNIX
ifneq (,$(findstring unix,$(platform)))
	TARGET := $(TARGET_NAME)_libretro.so
	fpic := -fPIC
	SHARED := -shared -Wl,-no-undefined
	TILED_RENDERING=1

# Classic Platforms ####################
# Platform affix = classic_<ISA>_<µARCH>
# Help at https://modmyclassic.com/comp

# (armv7 a7, hard point, neon based) ###
# NESC, SNESC, C64 mini
else ifeq ($(platform), classic_armv7_a7)
	TARGET := $(TARGET_NAME)_libretro.so
	fpic := -fPIC
	SHARED := -shared -Wl,--no-undefined -fPIC
	CFLAGS += -Ofast \
	-flto=4 -fwhole-program -fuse-linker-plugin \
	-fdata-sections -ffunction-sections -Wl,--gc-sections \
	-fno-stack-protector -fno-ident -fomit-frame-pointer \
	-falign-functions=1 -falign-jumps=1 -falign-loops=1 \
	-fno-unwind-tables -fno-asynchronous-unwind-tables -fno-unroll-loops \
	-fmerge-all-constants -fno-math-errno \
	-marm -mtune=cortex-a7 -mfpu=neon-vfpv4 -mfloat-abi=hard
	CXXFLAGS += $(CFLAGS)
	CPPFLAGS += $(CFLAGS)
	ASFLAGS += $(CFLAGS)
	HAVE_NEON=1
	ARCH = arm
	BUILTIN_GPU = neon
	USE_DYNAREC=1
	TILED_RENDERING=1
	ifeq ($(shell echo `$(CC) -dumpversion` "< 4.9" | bc -l), 1)
	  CFLAGS += -march=armv7-a
	else
	  CFLAGS += -march=armv7ve
	  # If gcc is 5.0 or later
	  ifeq ($(shell echo `$(CC) -dumpversion` ">= 5" | bc -l), 1)
	    LDFLAGS += -static-libgcc -static-libstdc++
	  endif
	endif

# (armv8 a35, hard point, neon based) ###
# PlayStation Classic
else ifeq ($(platform), classic_armv8_a35)
	TARGET := $(TARGET_NAME)_libretro.so
	fpic := -fPIC
	SHARED := -shared
	TILED_RENDERING=1
	CFLAGS += -Ofast \
	-flto=4 -fwhole-program -fuse-linker-plugin \
	-fdata-sections -ffunction-sections -Wl,--gc-sections \
	-fno-stack-protector -fno-ident -fomit-frame-pointer \
	-falign-functions=1 -falign-jumps=1 -falign-loops=1 \
	-fno-unwind-tables -fno-asynchronous-unwind-tables -fno-unroll-loops \
	-fmerge-all-constants -fno-math-errno \
	-marm -mtune=cortex-a35 -mfpu=neon-fp-armv8 -mfloat-abi=hard
	CXXFLAGS += $(CFLAGS)
	HAVE_NEON=1
	ARCH = arm
	ifeq ($(shell echo `$(CC) -dumpversion` "< 4.9" | bc -l), 1)
	  CFLAGS += -march=armv8-a
	else
	  CFLAGS += -march=armv8-a
	  # If gcc is 5.0 or later
	  ifeq ($(shell echo `$(CC) -dumpversion` ">= 5" | bc -l), 1)
	    LDFLAGS += -static-libgcc -static-libstdc++
	  endif
	endif
#######################################

# OS X
else ifeq ($(platform), osx)
	TARGET := $(TARGET_NAME)_libretro.dylib
	fpic := -fPIC
	ifeq ($(arch),ppc)
	  ENDIANNESS_DEFINES += -DMSB_FIRST
	  PLATFORM_DEFINES := -D__POWERPC__ -D__ppc__
	endif
	OSXVER = `sw_vers -productVersion | cut -d. -f 2`
	OSX_LT_MAVERICKS = `(( $(OSXVER) <= 9)) && echo "YES"`
	MINVERSION =
ifeq ($(OSX_LT_MAVERICKS),"YES")
	MINVERSION = -mmacosx-version-min=10.2
else
	MINVERSION = -mmacosx-version-min=10.7
endif
ifeq ($(shell uname -p),arm)
	MINVERSION =
endif
   ifeq ($(CROSS_COMPILE),1)
		TARGET_RULE   = -target $(LIBRETRO_APPLE_PLATFORM) -isysroot $(LIBRETRO_APPLE_ISYSROOT)
		CFLAGS   += $(TARGET_RULE)
		CPPFLAGS += $(TARGET_RULE)
		CXXFLAGS += $(TARGET_RULE)
		LDFLAGS  += $(TARGET_RULE)
		MINVERSION =
   endif
	fpic += $(MINVERSION) -stdlib=libc++
	SHARED := -dynamiclib
	TILED_RENDERING=1

# iOS
else ifneq (,$(findstring ios,$(platform)))
	TARGET := $(TARGET_NAME)_libretro_ios.dylib
	fpic := -fPIC
	SHARED := -dynamiclib
        MINVERSION :=
	ifeq ($(IOSSDK),)
	  IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
	endif
	ifeq ($(platform),ios-arm64)
	  CC = cc -arch arm64 -isysroot $(IOSSDK)
	  CXX = clang++ -arch arm64 -isysroot $(IOSSDK)
	else
	  CC = cc -arch armv7 -isysroot $(IOSSDK)
	  CXX = clang++ -arch armv7 -isysroot $(IOSSDK)
	endif
	CFLAGS += -DIOS
	ifeq ($(platform),$(filter $(platform),ios9 ios-arm64))
	  MINVERSION = -miphoneos-version-min=8.0
	else
	  MINVERSION = -miphoneos-version-min=5.0
	endif
        CFLAGS += $(MINVERSION)
	TILED_RENDERING=1

else ifeq ($(platform), tvos-arm64)
   TARGET := $(TARGET_NAME)_libretro_tvos.dylib
   fpic := -fPIC
   SHARED := -dynamiclib -DLSB_FIRST
ifeq ($(IOSSDK),)
   IOSSDK := $(shell xcodebuild -version -sdk appletvos Path)
endif
   TILED_RENDERING = 1
   CC = cc -arch arm64 -isysroot $(IOSSDK)
   CXX = c++ -arch arm64 -isysroot $(IOSSDK)

# Theos iOS
else ifeq ($(platform), theos_ios)
	DEPLOYMENT_IOSVERSION = 5.0
	TARGET = iphone:latest:$(DEPLOYMENT_IOSVERSION)
	ARCHS = armv7 armv7s
	TARGET_IPHONEOS_DEPLOYMENT_VERSION=$(DEPLOYMENT_IOSVERSION)
	THEOS_BUILD_DIR := objs
	include $(THEOS)/makefiles/common.mk
	LIBRARY_NAME = $(TARGET_NAME)_libretro_ios
	TILED_RENDERING=1

# QNX
else ifeq ($(platform), qnx)
	TARGET := $(TARGET_NAME)_libretro_$(platform).so
	fpic := -fPIC
	SHARED := -lcpp -lm -shared -Wl,-no-undefined
	CC = qcc -Vgcc_ntoarmv7le
	CXX = QCC -Vgcc_ntoarmv7le_cpp
	AR = QCC -Vgcc_ntoarmv7le
	PLATFORM_DEFINES := -D__BLACKBERRY_QNX__ -marm -mcpu=cortex-a9 -mfpu=neon -mfloat-abi=softfp
	TILED_RENDERING=1

# Lightweight PS3 Homebrew SDK
else ifeq ($(platform), psl1ght)
	TARGET := $(TARGET_NAME)_libretro_psl1ght.a
	CC = $(PS3DEV)/ppu/bin/ppu-gcc$(EXE_EXT)
	CXX = $(PS3DEV)/ppu/bin/ppu-g++$(EXE_EXT)
	AR = $(PS3DEV)/ppu/bin/ppu-ar$(EXE_EXT)
	ENDIANNESS_DEFINES += -DMSB_FIRST
	PLATFORM_DEFINES := -D__PS3__ -D__POWERPC__ -D__ppc__
	STATIC_LINKING=1
	TILED_RENDERING=1

# PSP1
else ifeq ($(platform), psp1)
	TARGET := $(TARGET_NAME)_libretro_$(platform).a
	CC = psp-gcc$(EXE_EXT)
	CXX = psp-g++$(EXE_EXT)
	AR = psp-ar$(EXE_EXT)
	PLATFORM_DEFINES := -DPSP
	CFLAGS += -G0
	CXXFLAGS += -G0
	STATIC_LINKING=1
	TILED_RENDERING=1

# Vita
else ifeq ($(platform), vita)
	TARGET := $(TARGET_NAME)_libretro_$(platform).a
	CC = arm-vita-eabi-gcc$(EXE_EXT)
	CXX = arm-vita-eabi-g++$(EXE_EXT)
	AR = arm-vita-eabi-ar$(EXE_EXT)
	PLATFORM_DEFINES := -DVITA
	__FLAGS := -marm -mfpu=neon -mtune=cortex-a9 -mcpu=cortex-a9 -mfloat-abi=hard -mword-relocations
	__FLAGS += -fno-optimize-sibling-calls -fno-strict-aliasing -fno-partial-inlining -fno-tree-vrp
	__FLAGS += -ffast-math -fsingle-precision-constant -funroll-loops -ftracer

	CFLAGS += $(__FLAGS)
	CXXFLAGS += $(__FLAGS)
	CXXFLAGS += -fno-exceptions -fno-rtti
	STATIC_LINKING=1
	TILED_RENDERING=1
	USE_CHEATS=0 #for performance boost.

	USE_THREADED_RENDERER=1
	USE_MOTION_SENSOR=1
	USE_FRAME_SKIP=1
	HAVE_NEON=1

# Libxenon
else ifeq ($(platform), xenon)
	TARGET := $(TARGET_NAME)_libretro_xenon360.a
	CC = xenon-gcc$(EXE_EXT)
	CXX = xenon-g++$(EXE_EXT)
	AR = xenon-ar$(EXE_EXT)
	ENDIANNESS_DEFINES += -DMSB_FIRST
	PLATFORM_DEFINES := -D__LIBXENON__ -D__POWERPC__ -D__ppc__
	STATIC_LINKING=1
	TILED_RENDERING=1

# Nintendo Game Cube
else ifeq ($(platform), ngc)
	TARGET := $(TARGET_NAME)_libretro_$(platform).a
	CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
	CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
	AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
	ENDIANNESS_DEFINES += -DMSB_FIRST -DWORDS_BIGENDIAN=1
	PLATFORM_DEFINES += -DGEKKO -DHW_DOL -mrvl -mcpu=750 -meabi -mhard-float -D__ppc__
	PLATFORM_DEFINES += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
	STATIC_LINKING=1
	TILED_RENDERING=1

# Nintendo Wii
else ifeq ($(platform), wii)
	TARGET := $(TARGET_NAME)_libretro_$(platform).a
	CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
	CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
	AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
	ENDIANNESS_DEFINES += -DMSB_FIRST -DWORDS_BIGENDIAN=1
	PLATFORM_DEFINES += -DGEKKO -DHW_RVL -mrvl -mcpu=750 -meabi -mhard-float -D__ppc__
	PLATFORM_DEFINES += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
	STATIC_LINKING=1
	TILED_RENDERING=1

# Nintendo WiiU
else ifeq ($(platform), wiiu)
	TARGET := $(TARGET_NAME)_libretro_$(platform).a
	CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
	CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
	AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
	ENDIANNESS_DEFINES += -DMSB_FIRST -DWORDS_BIGENDIAN=1
	PLATFORM_DEFINES += -DGEKKO -DWIIU -DHW_WUP -mcpu=750 -meabi -mhard-float -D__ppc__
	PLATFORM_DEFINES += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
	STATIC_LINKING=1
	TILED_RENDERING=1

# Nintendo Switch (libnx)
else ifeq ($(platform), libnx)
	include $(DEVKITPRO)/libnx/switch_rules
	TARGET := $(TARGET_NAME)_libretro_$(platform).a
	DEFINES := -DSWITCH=1 -U__linux__ -U__linux -DRARCH_INTERNAL -DHAVE_THREADS=1
	CFLAGS := $(DEFINES) -g -O3 \
		-fPIE -I$(LIBNX)/include/ -ffunction-sections -fdata-sections -ftls-model=local-exec -Wl,--allow-multiple-definition -specs=$(LIBNX)/switch.specs
	CFLAGS += $(INCDIRS)
	CFLAGS += $(INCLUDE) -D__SWITCH__ -DHAVE_LIBNX
	CXXFLAGS := $(ASFLAGS) $(CFLAGS) -fno-rtti -fno-exceptions
	STATIC_LINKING=1

# Nintendo Switch (devkitpro)
else ifeq ($(platform), switch)
	TARGET := $(TARGET_NAME)_libretro_$(platform).a
	CC = $(DEVKITPRO)/devkitA64/bin/aarch64-none-elf-gcc$(EXE_EXT)
	CXX = $(DEVKITPRO)/devkitA64/bin/aarch64-none-elf-g++$(EXE_EXT)
	AR = $(DEVKITPRO)/devkitA64/bin/aarch64-none-elf-ar$(EXE_EXT)
	STATIC_LINKING=1
	TILED_RENDERING=1

else ifneq (,$(findstring armv,$(platform)))
	TARGET := $(TARGET_NAME)_libretro.so
	SHARED := -shared -Wl,--no-undefined
	TILED_RENDERING=1
	fpic := -fPIC
	ifneq (,$(findstring cortexa8,$(platform)))
	  PLATFORM_DEFINES += -marm -mcpu=cortex-a8
	else ifneq (,$(findstring cortexa9,$(platform)))
	  PLATFORM_DEFINES += -marm -mcpu=cortex-a9
	endif
	PLATFORM_DEFINES += -marm
	ifneq (,$(findstring neon,$(platform)))
	  PLATFORM_DEFINES += -mfpu=neon
	  HAVE_NEON=1
	endif
	ifneq (,$(findstring softfloat,$(platform)))
	  PLATFORM_DEFINES += -mfloat-abi=softfp
	else ifneq (,$(findstring hardfloat,$(platform)))
	  PLATFORM_DEFINES += -mfloat-abi=hard
	endif
	PLATFORM_DEFINES += -DARM

# Emscripten
else ifeq ($(platform), emscripten)
	TARGET := $(TARGET_NAME)_libretro_$(platform).bc
	STATIC_LINKING=1

# Windows MSVC 2003 Xbox 1
else ifeq ($(platform), xbox1_msvc2003)
	TARGET := $(TARGET_NAME)_libretro_xdk1.lib
	CC  = CL.exe
	CXX = CL.exe
	LD  = lib.exe
	export INCLUDE := $(XDK)\xbox\include
	export LIB := $(XDK)\xbox\lib
	PATH := $(call unixcygpath,$(XDK)/xbox/bin/vc71):$(PATH)
	PSS_STYLE :=2
	CFLAGS   += -D_XBOX -D_XBOX1
	CXXFLAGS += -D_XBOX -D_XBOX1
	TILED_RENDERING=1
	STATIC_LINKING=1
	HAS_GCC := 0

# Windows MSVC 2010 Xbox 360
else ifeq ($(platform), xbox360_msvc2010)
	TARGET := $(TARGET_NAME)_libretro_xdk360.lib
	MSVCBINDIRPREFIX = $(XEDK)/bin/win32
	CC  = "$(MSVCBINDIRPREFIX)/cl.exe"
	CXX = "$(MSVCBINDIRPREFIX)/cl.exe"
	LD  = "$(MSVCBINDIRPREFIX)/lib.exe"
	export INCLUDE := $(XEDK)/include/xbox
	export LIB := $(XEDK)/lib/xbox
	PSS_STYLE :=2
	TILED_RENDERING=1

=== src/sdl/CMakeLists.txt ===
if(NOT ENABLE_SDL)
    return()
endif()

# Define the vbam executable.
add_executable(vbam WIN32)

target_sources(vbam
    PRIVATE
    audio_sdl.cpp
    audio_sdl.h
    ConfigManager.cpp
    ConfigManager.h
    dictionary.c
    dictionary.h
    expr.cpp
    expr.cpp.h
    exprNode.cpp
    exprNode.h
    expr-lex.cpp
    filters.cpp
    filters.h
    iniparser.c
    iniparser.h
    inputSDL.cpp
    inputSDL.h
    SDL.cpp
)

if(MSVC)
    # We should probably use an external library for this.
    target_sources(vbam
        PRIVATE
        ${CMAKE_SOURCE_DIR}/dependencies/msvc/getopt.c
        ${CMAKE_SOURCE_DIR}/dependencies/msvc/getopt.h
    )
endif()

if(ENABLE_LIRC)
    set(LIRC_CLIENT_LIBRARY lirc_client)
endif()

target_include_directories(vbam
    PRIVATE ${SDL2_INCLUDE_DIRS}
)

target_link_libraries(vbam
    vbam-core
    vbam-components-draw-text
    vbam-components-filters
    vbam-components-filters-agb
    vbam-components-filters-interframe
    vbam-components-user-config
    ${OPENGL_LIBRARIES}
    ${VBAM_SDL2_LIBS}
)

if(WIN32)
    target_link_libraries(vbam ${SDL2_LIBRARY} ${SDL2MAIN_LIBRARY})
endif()

if(ENABLE_LIRC)
    target_link_libraries(vbam lirc_client)
    target_compile_definitions(vbam PUBLIC VBAM_ENABLE_LIRC)
endif()

if(WIN32)
    target_link_libraries(vbam wsock32 ws2_32 winmm version imm32 ${SDL2MAIN_LIBRARY})
endif()

# Installation scripts.
install(
    PROGRAMS ${PROJECT_BINARY_DIR}/vbam${CMAKE_EXECUTABLE_SUFFIX}
    DESTINATION ${CMAKE_INSTALL_BINDIR}
)
install(
    FILES ${CMAKE_CURRENT_LIST_DIR}/vbam.cfg-example
    DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}
    RENAME vbam.cfg
)

if(UNIX)
    # man pages.
    install(FILES ${CMAKE_SOURCE_DIR}/src/debian/vbam.6 DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)
endif()

=== src/wx/CMakeLists.txt ===
if(NOT TRANSLATIONS_ONLY AND NOT ENABLE_WX)
    return()
endif()

# Do not use this file directly.  Always use the top level CMakeLists.txt file
include(VbamFunctions)

set(VBAM_WX_COMMON
    audio/audio.cpp
    audio/audio.h
    audio/internal/openal.cpp
    audio/internal/openal.h
    background-input.cpp
    background-input.h
    cmdevents.cpp
    dialogs/accel-config.cpp
    dialogs/accel-config.h
    dialogs/base-dialog.cpp
    dialogs/base-dialog.h
    dialogs/directories-config.cpp
    dialogs/directories-config.h
    dialogs/display-config.cpp
    dialogs/display-config.h
    dialogs/game-boy-config.cpp
    dialogs/game-boy-config.h
    dialogs/game-maker.cpp
    dialogs/game-maker.h
    dialogs/gb-rom-info.cpp
    dialogs/gb-rom-info.h
    dialogs/joypad-config.cpp
    dialogs/joypad-config.h
    dialogs/sound-config.cpp
    dialogs/sound-config.h
    dialogs/speedup-config.cpp
    dialogs/speedup-config.h
    drawing.h
    extra-translations.cpp
    gfxviewers.cpp
    guiinit.cpp
    ioregs.h
    opts.cpp
    opts.h
    panel.cpp
    rpi.h
    sys.cpp
    viewers.cpp
    viewsupt.cpp
    viewsupt.h
    wayland.cpp
    wayland.h
    wxhead.h
    wxlogdebug.h
    wxvbam.cpp
    wxvbam.h
    x11keymap.h
    xrc/visualboyadvance-m.xpm
    # Generated files.
    ${VBAM_GENERATED_DIR}/wx/builtin-xrc.h
    ${VBAM_GENERATED_DIR}/wx/builtin-over.h
    ${VBAM_GENERATED_DIR}/wx/cmdhandlers.h
    ${VBAM_GENERATED_DIR}/wx/cmd-evtable.h
)

if(NOT ZIP_PROGRAM)
    find_program(ZIP_PROGRAM zip DOC "zip compressor executable")
    if(WIN32 AND NOT ZIP_PROGRAM AND NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/zip.exe)
        if(NOT DEFINED POWERSHELL)
            message(FATAL_ERROR "Powershell is required for extraction.")
        endif()

        # Get zip binaries from wxrc.
        file(DOWNLOAD "https://www.willus.com/archive/zip64/infozip_binaries_win32.zip" ${CMAKE_CURRENT_BINARY_DIR}/infozip_binaries_win32.zip)

        # Unzip it.
        execute_process(
            COMMAND "${POWERSHELL}" -NoLogo -NoProfile -ExecutionPolicy Bypass -Command "& { Add-Type -A 'System.IO.Compression.FileSystem'; [IO.Compression.ZipFile]::ExtractToDirectory('${CMAKE_CURRENT_BINARY_DIR}/infozip_binaries_win32.zip', '${CMAKE_CURRENT_BINARY_DIR}'); }"
        )

        set(ZIP_PROGRAM ${CMAKE_CURRENT_BINARY_DIR}/zip.exe CACHE STRING "zip compressor executable" FORCE)
    endif()
    if(ZIP_PROGRAM)
        set(ZIP_PROGRAM "${ZIP_PROGRAM}" CACHE STRING "zip compressor executable" FORCE)
    else(NOT ZIP_PROGRAM)
        message(FATAL_ERROR "The zip compressor program is required for building.")
    endif()
endif()

if(MSVC)
    # Install gettext tools from nuget.

    # First fetch the nuget binary.
    if(NOT EXISTS ${CMAKE_BINARY_DIR}/nuget.exe)
        file(DOWNLOAD "https://dist.nuget.org/win-x86-commandline/latest/nuget.exe" ${CMAKE_BINARY_DIR}/nuget.exe)
    endif()

    # Add nuget package source.
    execute_process(
        COMMAND nuget sources add -Name "NuGet official package source" -Source "https://api.nuget.org/v3/index.json"
        OUTPUT_QUIET
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

    # Install the Gettext.Tools package.
    execute_process(
        COMMAND nuget.exe install Gettext.Tools -OutputDirectory ${CMAKE_BINARY_DIR}/nuget
        OUTPUT_QUIET
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

    # Find the path to the binaries in the package and add them to find path.
    file(GLOB pkg ${CMAKE_BINARY_DIR}/nuget/Gettext.Tools*)

    list(APPEND CMAKE_PROGRAM_PATH ${pkg}/tools/bin)
endif()

find_package(Gettext REQUIRED)
find_program(XGETTEXT xgettext)
find_program(MSGINIT  msginit)

if(NOT XGETTEXT OR NOT MSGINIT)
    message(SEND_ERROR "Cannot find gettext xgettext:'${XGETTEXT}' msginit:'${MSGINIT}'")
endif()

# Make the translations.zip
add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/translations.zip
    COMMAND ${CMAKE_COMMAND} -D "ZIP_PROGRAM=${ZIP_PROGRAM}" -P ${CMAKE_CURRENT_SOURCE_DIR}/make-translations-zip.cmake
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    DEPENDS translations make-translations-zip.cmake
)
add_custom_target(
    translations-zip
    ALL
    SOURCES ${CMAKE_BINARY_DIR}/translations.zip
)

if(TRANSLATIONS_ONLY)
    # Nothing more to do if we are only building the translations.zip file.
    return()
endif()

# wxWidgets configuration.
set(wxWidgets_USE_UNICODE ON)
if(CMAKE_BUILD_TYPE MATCHES "^(Debug|RelWithDebInfo)$")
    set(wxWidgets_USE_DEBUG ON) # noop if wx is compiled with --disable-debug, like in Mac Homebrew atm
endif()
if(VBAM_STATIC)
    set(wxWidgets_USE_STATIC ON)
endif()

unset(wx_find_extra)
if(CMAKE_TOOLCHAIN_FILE MATCHES "vcpkg")
  set(wx_find_extra NO_DEFAULT_PATH)
  set(wxWidgets_DIR "${VCPKG_ROOT}/installed/${VCPKG_TARGET_TRIPLET}/share/wxwidgets")
endif()

set(ENABLE_OPENGL TRUE)
find_package(wxWidgets COMPONENTS xrc xml html adv net core base gl ${wx_find_extra})

if(NOT wxWidgets_FOUND)
    find_package(wxWidgets COMPONENTS xrc xml html adv net core base ${wx_find_extra} REQUIRED)
    set(ENABLE_OPENGL FALSE)
endif()

# Find OpenAL (required).
find_package(OpenAL REQUIRED)

# Workaround of static liblzma not being found on MSYS2.
if(VBAM_STATIC AND MSYS)
    unset(cleaned_up_wx_libs)
    foreach(lib ${wxWidgets_LIBRARIES})
        if(lib STREQUAL "-llzma")
            set(lib "liblzma.a")
        endif()

        list(APPEND cleaned_up_wx_libs "${lib}")
    endforeach()

    set(wxWidgets_LIBRARIES "${cleaned_up_wx_libs}")
endif()

list(APPEND CMAKE_REQUIRED_LIBRARIES ${wxWidgets_LIBRARIES})
list(APPEND CMAKE_REQUIRED_INCLUDES ${wxWidgets_INCLUDE_DIRS})
list(APPEND CMAKE_REQUIRED_FLAGS ${wxWidgets_CXX_FLAGS})
foreach(DEF ${wxWidgets_DEFINITIONS})
    list(APPEND CMAKE_REQUIRED_DEFINITIONS "-D${DEF}")
endforeach()

# Configure common settings for wx-based targets, like linking, include
# directories, compile options, and definitions.
function(configure_wx_target target)
    get_target_property(target_type ${target} TYPE)
    if(target_type STREQUAL "EXECUTABLE")
        set(target_is_executable TRUE)
    else()
        set(target_is_executable FALSE)
    endif()

    function(_add_link_libraries)
        if(${target_is_executable})
            target_link_libraries(${target} ${ARGN})
        else()
            target_link_libraries(${target} PUBLIC ${ARGN})
        endif()
    endfunction()

    function(_add_include_directories)
        if(${target_is_executable})
            target_include_directories(${target} PRIVATE ${ARGN})
        else()
            target_include_directories(${target} PUBLIC ${ARGN})
        endif()
    endfunction()

    function(_add_compile_options)
        if(${target_is_executable})
            target_compile_options(${target} PRIVATE ${ARGN})
        else()
            target_compile_options(${target} PUBLIC ${ARGN})
        endif()
    endfunction()

    function(_add_compile_definitions)
        if(${target_is_executable})
            target_compile_definitions(${target} PRIVATE ${ARGN})
        else()
            target_compile_definitions(${target} PUBLIC ${ARGN})
        endif()
    endfunction()

    # Core emulator.
    _add_link_libraries(vbam-core)

    # Nonstd.
    _add_link_libraries(nonstd-lib)
    _add_include_directories(${NONSTD_INCLUDE_DIR})

    # wxWidgets.
    _add_link_libraries(${wxWidgets_LIBRARIES})
    _add_include_directories(${wxWidgets_INCLUDE_DIRS})
    _add_compile_options(${wxWidgets_CXX_FLAGS})
    _add_compile_definitions(${wxWidgets_DEFINITIONS})
    if(CMAKE_BUILD_TYPE MATCHES "^(Debug|RelWithDebInfo)$")
        _add_compile_definitions(${wxWidgets_DEFINITIONS_DEBUG})
    endif()

    # OpenAL.
    if(OPENAL_STATIC)
        _add_compile_definitions(AL_LIBTYPE_STATIC)
    endif()
    _add_include_directories(${OPENAL_INCLUDE_DIR})
    _add_link_libraries(${OPENAL_LIBRARY})

    # XAudio2.
    if(ENABLE_XAUDIO2)
        _add_compile_definitions(VBAM_ENABLE_XAUDIO2)
    endif()

    # FAudio.
    if(ENABLE_FAUDIO)
        _add_compile_definitions(VBAM_ENABLE_FAUDIO)
        if(MSVC)
            _add_link_libraries(FAudio::FAudio)
        else()
            _add_link_libraries(FAudio)
            if(WIN32)
                _add_link_libraries(dxguid uuid winmm ole32 advapi32 user32 mfplat mfreadwrite mfuuid propsys)
            endif()
        endif()
    endif()

    # Direct3D.
    if(NOT ENABLE_DIRECT3D)
        _add_compile_definitions(NO_D3D)
    endif()

    # SDL2.
    _add_link_libraries(${VBAM_SDL2_LIBS})

    # OpenGL.
    if(ENABLE_OPENGL)
        _add_link_libraries(${OPENGL_LIBRARIES})
    else()
        _add_compile_definitions(NO_OGL)
    endif()

endfunction()

# Sub-projects.
add_subdirectory(test)
add_subdirectory(config)
add_subdirectory(widgets)

set(VBAM_ICON visualboyadvance-m.icns)
set(VBAM_ICON_PATH ${CMAKE_CURRENT_SOURCE_DIR}/icons/${VBAM_ICON})

add_executable(
    visualboyadvance-m
    WIN32
    MACOSX_BUNDLE
)

target_sources(visualboyadvance-m PRIVATE ${VBAM_WX_COMMON} ${VBAM_ICON_PATH})
target_include_directories(visualboyadvance-m PRIVATE ${SDL2_INCLUDE_DIRS})

target_link_libraries(
    visualboyadvance-m
    vbam-components-draw-text
    vbam-components-filters
    vbam-components-filters-agb
    vbam-components-filters-interframe
    vbam-components-user-config
    vbam-wx-config
    vbam-wx-widgets
)

# adjust link command when making a static binary for gcc
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND VBAM_STATIC)
    if(MSYS)
        add_custom_command(
            TARGET visualboyadvance-m PRE_LINK
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/msys-link-static.cmake
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    else()
        add_custom_command(
            TARGET visualboyadvance-m PRE_LINK
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/link-static.cmake
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )
    endif()
endif()

add_dependencies(visualboyadvance-m translations-zip)

# on unix we have to check for X11 before we overwrite all the compile/link
# flags with the wx tests
if(NOT WIN32 AND NOT APPLE)
    find_package(X11)

    if(X11_X11_LIB)
        target_include_directories(visualboyadvance-m PRIVATE ${X11_INCLUDE_DIR})
        target_link_libraries(visualboyadvance-m ${X11_X11_LIB})
        target_compile_definitions(visualboyadvance-m PRIVATE HAVE_X11)
        if(X11_Xscreensaver_LIB)
        target_link_libraries(visualboyadvance-m ${X11_Xscreensaver_LIB})
            target_compile_definitions(visualboyadvance-m PRIVATE HAVE_XSS)
        endif()
    endif()

    find_library(EGL_LIBRARY EGL)

    if(EGL_LIBRARY)
    target_link_libraries(visualboyadvance-m ${EGL_LIBRARY})
        target_compile_definitions(visualboyadvance-m PRIVATE HAVE_EGL)
    endif()

    find_library(WAYLAND_LIBRARY wayland-client)
    if(WAYLAND_LIBRARY)
        target_link_libraries(visualboyadvance-m ${WAYLAND_LIBRARY})
    endif()
endif()

if(WIN32)
    target_sources(visualboyadvance-m
        PRIVATE
        audio/internal/dsound.cpp
        wxvbam.rc
    )
    target_link_libraries(visualboyadvance-m
        dxguid dsound wsock32 ws2_32 imm32 version winmm)

    # Force a re-link when the manifest file is modified.
    set_target_properties(visualboyadvance-m
        PROPERTIES
        LINK_DEPENDS
        "${CMAKE_CURRENT_LIST_DIR}/visualboyadvance-m.manifest")

    if(MSVC)
        # Disable the auto-generated manifest from CMake.
        target_link_options(visualboyadvance-m PRIVATE "/MANIFEST:NO")
    endif()

    # wxWidgets fails to bring in its dependency.
    find_library(PCRE_LIB pcre2-16 REQUIRED)
    target_link_libraries(visualboyadvance-m ${PCRE_LIB})
endif()

if(APPLE)
    target_sources(visualboyadvance-m PRIVATE
        macsupport.mm
    )
endif()

# link libgcc/libstdc++ statically on mingw
# and adjust link command when making a static binary
if(CMAKE_COMPILER_IS_GNUCXX AND VBAM_STATIC)

=== src/components/av_recording/CMakeLists.txt ===
if(NOT ENABLE_FFMPEG)
    return()
endif()

add_library(vbam-components-av-recording OBJECT)

target_sources(vbam-components-av-recording
    PRIVATE av_recording.cpp
    PUBLIC av_recording.h
)

target_include_directories(vbam-components-av-recording
    PUBLIC ${FFMPEG_INCLUDE_DIRS}
)

target_link_libraries(vbam-components-av-recording
    PUBLIC ${FFMPEG_LIBRARIES}
)

=== src/components/draw_text/CMakeLists.txt ===
add_library(vbam-components-draw-text OBJECT)

target_sources(vbam-components-draw-text
    PRIVATE draw_text.cpp
    PUBLIC draw_text.h
)

target_link_libraries(vbam-components-draw-text
    PRIVATE vbam-core-base
)

=== src/components/filters/CMakeLists.txt ===
add_library(vbam-components-filters OBJECT)

target_sources(vbam-components-filters
    PRIVATE
    internal/2xSaI.cpp
    internal/admame.cpp
    internal/bilinear.cpp
    internal/hq2x.cpp
    internal/hq2x.h
    internal/interp.h
    internal/lq2x.h
    internal/pixel.cpp
    internal/scanline.cpp
    internal/simpleFilter.cpp
    internal/xBRZ/xbrz.cpp
    internal/xBRZ/xbrz.h
    internal/xBRZ/xbrz_config.h
    internal/xBRZ/xbrz_tools.h
    internal/xbrzfilter.cpp

    PUBLIC
    filters.h
)

if(ENABLE_ASM_SCALERS)
    target_sources(vbam-components-filters
        PRIVATE
        internal/hq/asm/hq3x_16.asm
        internal/hq/asm/hq3x_32.asm
        internal/hq/asm/hq4x_16.asm
        internal/hq/asm/hq4x_32.asm
        internal/hq/asm/hq3x32.cpp
        internal/hq/asm/macros.mac
    )
    if(ENABLE_MMX)
        set(SRC_FILTERS ${SRC_FILTERS} internal/2xSaImmx.asm)
    endif()
else()
    target_sources(vbam-components-filters
        PRIVATE
        internal/hq/c/hq3x_pattern.h
        internal/hq/c/hq4x_pattern.h
        internal/hq/c/hq_base.h
        internal/hq/c/hq_implementation.cpp
        internal/hq/c/hq_shared.h
    )
endif()

=== src/components/filters_agb/CMakeLists.txt ===
add_library(vbam-components-filters-agb OBJECT)

target_sources(vbam-components-filters-agb
    PRIVATE filters_agb.cpp
    PUBLIC filters_agb.h
)

=== src/components/filters_interframe/CMakeLists.txt ===
add_library(vbam-components-filters-interframe OBJECT)

target_sources(vbam-components-filters-interframe
    PRIVATE interframe.cpp
    PUBLIC interframe.h
)

=== src/debian/changelog ===
vbam (1.8.0.1458-1) UNRELEASED; urgency=low

  * Update some commits of 2.0.0 beta 1.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Wed, 20 May 2015 18:30:00 -0300

vbam (1.8.0.1447-1) UNRELEASED; urgency=low

  * Update, 2.0.0 beta 1 release.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Mon, 18 May 2015 17:01:00 -0300

vbam (1.8.0.1231-3) UNRELEASED; urgency=low

  * Revert SDL sound changes to upstream svn 1226, until they fix it (bug #147)

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 11 May 2014 11:09:00 +0100

vbam (1.8.0.1231-2) UNRELEASED; urgency=low

  * Manual merge from upstream

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 11 May 2014 11:08:00 +0100

vbam (1.8.0.1231-1) UNRELEASED; urgency=low

  * Re-added rWindows/other stuff (easy recipe to merge upstream changes to fixes)
  * New icons

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 11 May 2014 09:20:00 +0100

vbam (1.8.0.1230-2) UNRELEASED; urgency=low

  * Added missing Build-Depends
  * Package for vbam-sdl
  * Fixed some lintian warnings/errors

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 27 Apr 2014 15:48:00 +0100

vbam (1.8.0.1230-1) UNRELEASED; urgency=low

  * Fixing launchpad orig.tar.gz error

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sat, 22 Mar 2014 16:23:00 +0100

vbam (1.8.0.1229-2) UNRELEASED; urgency=low

  * Updated copyright year and fixed homepage link

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sat, 22 Mar 2014 15:59:00 +0100

vbam (1.8.0.1229-1) UNRELEASED; urgency=low

  * Use new version from upstream

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Thu, 20 Mar 2014 19:30:00 +0100

vbam (1.8.0.1042-1) lucid; urgency=low

  * Use new version from upstream

 -- Bastien Bouclet <bgk@users.sourceforge.net>  Sun, 04 Dec 2011 08:48:11 +0100

vbam (1.8.0.1016-1) unstable; urgency=low

  * Use new version from upstream, with wxwidgets patches

 -- Thomas J. Moore <darktjm@gmail.com>  Sun, 22 May 2011 14:08:05 -0500

vbam (1.8.0.1001-1) unstable; urgency=low

  * Use new version from upstream

 -- Bastien Bouclet <bgk@users.sourceforge.net>  Fri, 25 Feb 2011 12:25:25 +0100

vbam (1.8.0.914-1) unstable; urgency=low

  * Cleanup, packages split into SDL and GTK+ versions

 -- Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>  Sun, 04 Oct 2009 19:58:09 -0300

vbam (1.8.0.913-1) unstable; urgency=low

  * Using assembly optmizations for i386 and amd64 platforms

 -- Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>  Sat, 03 Oct 2009 22:41:55 -0300

vbam (1.8.0.912-1) unstable; urgency=low

  * Added libglademm-2.4-dev as a build-time dependency

 -- Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>  Sun, 27 Sep 2009 23:26:23 -0300

vbam (1.8.0.905-1) unstable; urgency=low

  * Initial release

 -- Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>  Sat, 12 Sep 2009 19:39:52 -0300

=== src/debian/control ===
Source: vbam
Section: otherosfs
Priority: optional
Maintainer: Sérgio Benjamim <sergio_br2@yahoo.com.br>
Build-Depends:	debhelper (>= 9),
				cmake (>= 2.6.0),
				imagemagick, 
				libopenal-dev, 
				libsdl2.0-dev, 
				libwxbase3.0-dev,
				libwxgtk3.0-dev, 
				libcairo2-dev, 
				libsfml-dev, 
				nasm [i386 amd64], 
				liblircclient-dev, 
				libavcodec-dev, 
				libavformat-dev, 
				libswscale-dev, 
				libavutil-dev,
				libgl1-mesa-dev,
				zip,
				zlib1g-dev
Standards-Version: 3.9.5
Homepage: http://visualboyadvance-m.org
Vcs-Svn: svn://svn.code.sf.net/p/vbam/code/trunk
Vcs-Browser: http://svn.code.sf.net/p/vbam/code/trunk

Package: vbam-sdl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Nintendo Game Boy Advance emulator
 VisualBoyAdvance-M is a Nintendo Game Boy Emulator with high compatibility
 with commercial games. It emulates the Nintendo Game Boy Advance handheld
 console, in addition to the original Game Boy handhelds and its Super and
 Color variants.
 .
 This package does not provide a GUI version of VBA-M.
 See the vbam-gtk package for the GTK+ version of this program.
 See the vbam-wx package for the wxWidgets version of this program.
 .
 Game Boy, Game Boy Color, Super Game Boy and Game Boy Advance are registered
 trademarks of Nintendo of America Inc. VBA-M is not affiliated with or endorsed
 by any of the companies mentioned.

Package: vbam-wx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Nintendo Game Boy Advance emulator (wxWidgets frontend)
 VisualBoyAdvance-M is a Nintendo Game Boy Emulator with high compatibility
 with commercial games. It emulates the Nintendo Game Boy Advance handheld
 console, in addition to the original Game Boy handhelds and its Super and
 Color variants.
 .
 This package provides the wxWidgets GUI version of VBA-M.
 .
 Game Boy, Game Boy Color, Super Game Boy and Game Boy Advance are registered
 trademarks of Nintendo of America Inc. VBA-M is not affiliated with or endorsed
 by any of the companies mentioned.

=== src/debian/rules ===
#!/usr/bin/make -f

# Copyright (C) 2014, 2015 Sergio Benjamim (sergio-br2) <sergio_br2@yahoo.com.br>
# Copyright (C) 2009 Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Uncomment this to turn on verbose mode
#export DH_VERBOSE=1

ifeq ($(DH_VERBOSE),1)
EXTRA_CMAKE_FLAGS += -DCMAKE_VERBOSE_MAKEFILE=ON
endif

#DEB_BUILD_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU)

#ifneq (,$(filter $(DEB_BUILD_ARCH_CPU),i386 amd64))
#EXTRA_CMAKE_FLAGS += -DUSE_ASM_SCALERS=ON -DUSE_ASM_CORE=ON
#endif

CMAKE_EXTRA_FLAGS += -DCMAKE_INSTALL_PREFIX=/usr \
						-DENABLE_LIRC=ON -DENABLE_LINK=ON \
						-DCMAKE_SKIP_RPATH=ON $(EXTRA_CMAKE_FLAGS)

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
